// Include the AccelStepper Library
#include <AccelStepper.h>

// Define step constant
#define MotorInterfaceType 4

int analogPin = A0; // potentiometer wiper (middle terminal) connected to analog pin 3
                    // outside leads to ground and +5V

const int potPin = A0;

float endPosition = -1500;
float currentPosition = 0;

// int desiredPosition=0;

int val = 0;  // variable to store the value read
//    int inPin = 7;    // pushbutton connected to digital pin 7
int val2 = 0;
int j = 0;

// Creates an instance
// Pins entered in sequence IN1-IN3-IN2-IN4 for proper step sequence
//AccelStepper myStepper(MotorInterfaceType, 8, 10, 9, 11);
AccelStepper myStepper(MotorInterfaceType, 9, 8, 10, 11);

void setup() {
	// set the maximum speed, acceleration factor,
	// initial speed and the target position
	myStepper.setMaxSpeed(1000.0);
	myStepper.setAcceleration(50.0);
	myStepper.setSpeed(600);
	// myStepper.moveTo(-1500);

  //    pinMode(inPin, INPUT);  // sets the digital pin 13 as output

  Serial.begin(9600);           //  setup serial

}

void loop() {

  // ---- Read Potentiometer and Print Voltage ----
  float potVal = analogRead(potPin);      // 0 to 1023
//  float voltage = potVal * (5.0 / 1023.0); // Convert to 0-5V range

  float desiredPosition = (potVal/1024)*endPosition;
  float moveVector = floor(currentPosition-desiredPosition);
  myStepper.moveTo(moveVector);
  currentPosition = currentPosition+moveVector;

  // Only print every 200 ms
  static unsigned long lastPrint = 0;
  if (millis() - lastPrint >= 200) {
    lastPrint = millis();
    Serial.println(
  "Voltage: " + String(potVal) +
  ", currentPosition: " + String(currentPosition) +
  ", desiredPosition: " + String(desiredPosition) +
  ", moveVector: " + String(moveVector)
  );
  }
  
	// Move the motor one step
	myStepper.run();

  // Serial.print("Current Position: ");
  // Serial.println(myStepper.currentPosition());
}

//  val =0;
 // val2 = 0;
 // for (j=0; j<2000; j++){
 //     val = val + analogRead(analogPin);  // read the input pin
 //     val2 = val2 + digitalRead(inPin);   // read the inpu t pin
 // }
 // val = val/2000;
 // val2 = val2/2000;
 // Serial.print(val2);
 // Serial.print("  ---   ");
 //     Serial.println(val );          // debug value
//}


// void loop() {
//   // Read and convert the potentiometer value
//   int potVal = analogRead(potPin);             // 0 to 1023
//   float voltage = potVal * (5.0 / 1023.0);     // convert to 0 - 5V range
  
//   // Print out the voltage (for debugging)
//   Serial.print("Voltage: ");
//   Serial.println(voltage);

//   // Compare against 2.5 V to decide rotation direction
//   if (voltage > 2.5) {
//     // Move the motor to the right (clockwise)
//     // Setting a positive speed
//     myStepper.setSpeed(200);   // steps/sec
//   } else {
//     // Move the motor to the left (counterclockwise)
//     // Setting a negative speed
//     myStepper.setSpeed(-200);  // steps/sec
//   }

//   // Run the motor continuously at the set speed
//   // runSpeed() does not use acceleration; it tries to maintain the set speed
//   myStepper.runSpeed();
// }